﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private cv As Canvas 	
	Private img As Image
	Private Pts(1,1) As PointApi	
	Private Initialized As Boolean
	Private wdt, hgt, xQt, yQt As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub initialize

End Sub
Public Sub WarpsImg(c As Canvas , aPn As Pane )
	cv = c
	img = c.Snapshot
	Dim x As Int
	Dim y As Int
	Dim mag0 As Float
	Dim per0 As Float
	Dim mag1 As Float
	Dim per1 As Float
	Dim mag2 As Float
	Dim per2 As Float
	Dim ix As Int
	Dim iy As Int
	Dim dx0 As Float
	Dim dy0 As Float
	Dim dx1 As Float
	Dim dy1 As Float
	Dim r As Int
	Dim g As Int
	Dim b As Int
	Dim r00 As Int
	Dim g00 As Int
	Dim b00 As Int
	Dim r01 As Int
	Dim g01 As Int
	Dim b01 As Int
	Dim r10 As Int
	Dim g10 As Int
	Dim b10 As Int
	Dim r11 As Int
	Dim g11 As Int
	Dim b11 As Int
	Dim clr As Paint
	Dim rgb(4) As Int 
    ' Draw the source image.
	wdt = img.Width 
	hgt=img.Height
	cv.Width =wdt
	cv.Height = hgt	

    mag0 = Rnd(2, 6)
    per0 = Rnd(20, 30)
    mag1 = Rnd(3, 6)
    per1 = Rnd(20, 40)
    mag2 = Rnd(1, 3)
    per2 = Rnd(10, 20)
	' Make the destination bitmap.
	Dim ARGB As Int
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	InputJO = img
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)	   
	For x = 0 To wdt - 1
		For y = 0 To hgt - 1
	        ' Find source (x, y).
			Dim s As PointApi 
	        s = InvertXY(mag0, per0, mag1, per1, mag2, per2, x, y)

	        ' Interpolate.
	        ix = s.x 
	        iy = s.y 
			
	        If ix < 0 OR ix >= wdt - 1 OR iy < 0 OR iy >= hgt - 1 Then
	            'nothing
	        Else
       			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(ix,iy))
				rgb = modFunctions.getRGB(ARGB)
				r00 = rgb(1):g00 = rgb(2):b00 = rgb(3)
       			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(ix + 1, iy))
				rgb = modFunctions.getRGB(ARGB)
				r10 = rgb(1):g10 = rgb(2):b10 = rgb(3)
       			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(ix, iy + 1))
				rgb = modFunctions.getRGB(ARGB)
				r01 = rgb(1):g01 = rgb(2):b01 = rgb(3) 
       			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(ix + 1, iy + 1))
				rgb = modFunctions.getRGB(ARGB)
				r11 = rgb(1):g11 = rgb(2):b11 = rgb(3) 

	            dx0 = s.x - ix
	            dy0 = s.y - iy
	            dx1 = 1 - dx0
	            dy1 = 1 - dy0
	            r = dy1 * (dx1 * r00 + dx0 * r10) + _
	                dy0 * (dx1 * r01 + dx0 * r11)
	            g = dy1 * (dx1 * g00 + dx0 * g10) + _
	                dy0 * (dx1 * g01 + dx0 * g11)
	            b = dy1 * (dx1 * b00 + dx0 * b10) + _
	                dy0 * (dx1 * b01 + dx0 * b11)
                
				r=Max(Min(r,255),0)
				g=Max(Min(g,255),0)
				b=Max(Min(b,255),0)
				clr = fx.Colors.rgb(r, g, b)
				ARGB=fx.Colors.To32Bit(clr)
				WriterJO.RunMethod("setArgb",Array As Object(x , y ,ARGB))					
	        End If
	    Next 
	Next 
	cv.DrawImage(OutputJO,0,0,wdt,hgt)	
	Initialized =True
End Sub
Private Sub InvertXY(mag0 As Float, per0 As Float, mag1 As Float, per1 As Float, mag2 As Float, per2 As Float, x As Int, y As Int) As PointApi
	Dim iv As PointApi 
    iv.x = x - mag0 * Cos(y * cPI / per0)
    iv.y = y - mag1 * Sin(x * cPI / per1) - mag2 * Sin(x * cPI / per2)
	Return iv
End Sub
