﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private wdt, hgt As Int
	Private fx As JFX
	Private cv As Canvas 	
	Private img As Image	
	Private AP As Pane		
	Private sldBrighter As Slider
	Private txtBrighter As TextField
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
AP.Initialize("")

End Sub
Public Sub HorizEdges(c As Canvas, fr As Form, posy As Double)
	cv = c
	img = cv.Snapshot 
	wdt = img.Width 
	hgt=img.Height
	AP.LoadLayout("fxHEdges")
	fr.RootPane.AddNode(AP, 5, posy, -1, -1)
	sldBrighter.MinValue=0
	sldBrighter.MaxValue=128
	sldBrighter.Value=4	
End Sub
Private Sub Draw_HorizEdges
	Dim EdgeValue As Int
	Dim x1 As Int  
	Dim r1, g1, b1 As Int
	Dim r2, g2, b2 As Int
	Dim r3, g3, b3 As Int
	Dim rgb(4) As Int
	Dim ARGB,  lEdge As Int
	Dim Clr As Paint	
	cv.ClearRect(0,0,cv.Width,cv.Height)	
	cv.DrawImage(img,0,0,wdt,hgt)	
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	EdgeValue = sldBrighter.Value 
	InputJO = img
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)
	For y=0 To hgt-1
		For x=0 To wdt -1
			If x< wdt-2 Then
				x1 = x
			Else If x < wdt -1 Then
				x1=x -1
			Else
				x1 = x-2
			End If
			
			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(x1+1,y))
			rgb = modFunctions.getRGB(ARGB)
			r1 = rgb(1)
			g1 = rgb(2)
			b1 = rgb(3)
			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(x1+2,y))
			rgb = modFunctions.getRGB(ARGB)
			r2 = rgb(1)
			g2 = rgb(2)
			b2 = rgb(3)
			
			If r1 = r2 Then r3 = 0
			If r1 > r2 Then
				r3 = r1 - r2
			Else
				r3 = r2 - r1
			End If

			If g1 = g2 Then g3 = 0
			If g1 > g2 Then
				g3 = g1 - g2
			Else
				g3 = g2 - g1
			End If
			If b1 = b2 Then b3 = 0
			If b1 > b2 Then
				b3 = b1 - b2
			Else
				b3 = b2 - b1
			End If
			r3=Min(255,r3*EdgeValue)
			g3=Min(255,g3*EdgeValue)
			b3=Min(255,b3*EdgeValue)
			Clr = fx.Colors.rgb(r3, g3, b3)
			ARGB=fx.Colors.To32Bit(Clr)		
			WriterJO.RunMethod("setArgb",Array As Object(x , y ,ARGB))				

		Next
	Next
	cv.DrawImage(OutputJO,0,0,wdt,hgt)					
End Sub
Sub txtBrighter_Action
	sldBrighter.RequestFocus 
End Sub
Sub txtBrighter_TextChanged (Old As String, New As String)
	Dim ch As String
	Dim lg As Int
	lg=New.Length
	If lg>0 Then
		lg=lg-1
		For i = 0 To lg
			ch=New.SubString2(i, i+1)
			If Not("0123456789".Contains(ch)) Then
				txtBrighter.Text =Old
				txtBrighter.SetSelection (lg, lg)
				Return
			End If
		Next
	End If			
End Sub
Sub txtBrighter_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtBrighter.Tag = 1
	Else
		txtBrighter.Text =Max(Min(txtBrighter.Text,sldBrighter.MaxValue),sldBrighter.MinValue)
		sldBrighter.Value= txtBrighter.Text
	End If		
End Sub
Sub sldBrighter_ValueChange (Value As Double)
	Dim v As Short =Value
	If txtBrighter.Tag = 1 Then
		txtBrighter.Tag = 0
	Else
		txtBrighter.Text = v
	End If
	Draw_HorizEdges		
End Sub