﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private wdt, hgt As Int
	Private fx As JFX
	Private cv As Canvas 	
	Private img As Image	
	Private AP As Pane	
	Private sldSize As Slider
	Private txtSize As TextField
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
AP.Initialize("")
End Sub
Public Sub Mosaic(c As Canvas, fr As Form, posy As Double)
	Dim ct As Int 
	cv = c
	img = cv.Snapshot 
	wdt = img.Width 
	hgt=img.Height
	ct=Min(wdt,hgt)
	AP.LoadLayout("fxMosaic")
	fr.RootPane.AddNode(AP, 5, posy, -1, -1)
	sldSize.MinValue=2
	sldSize.MaxValue=ct/3
	sldSize.Value=5
End Sub
Private Sub DrawMosaic
	Dim r,g,b As Int
	Dim rgb(4) As Int
	Dim stp As Int 
	Dim ARGB,  lNeg As Int
	Dim clr As Paint
	Dim InputJO, ReaderJO As JavaObject
	InputJO = img
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	cv.ClearRect(0,0,cv.Width,cv.Height)	
	cv.ClearRect(0,0,cv.Width,cv.Height)	
	cv.DrawImage(img,0,0,wdt,hgt)	
	stp = sldSize.Value 
	For x = 0 To wdt-2 Step stp
		For y = 0 To hgt-2 Step stp
			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(x+1,y+1))
			clr = fx.Colors.From32Bit(ARGB)
			cv.DrawRect(x,y,stp,stp,clr,True,0)
		Next
	Next
	
End Sub
Sub txtSize_Action
	sldSize.RequestFocus 
End Sub
Sub txtSize_TextChanged (Old As String, New As String)
	Dim ch As String
	Dim lg As Int
	lg=New.Length
	If lg>0 Then
		lg=lg-1
		For i = 0 To lg
			ch=New.SubString2(i, i+1)
			If Not("0123456789".Contains(ch)) Then
				txtSize.Text =Old
				txtSize.SetSelection (lg, lg)
				Return
			End If
		Next
	End If		
End Sub
Sub txtSize_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtSize.Tag = 1
	Else
		txtSize.Text =Max(Min(txtSize.Text,sldSize.MaxValue),sldSize.MinValue)
		sldSize.Value= txtSize.Text
	End If			
End Sub
Sub sldSize_ValueChange (Value As Double)
	Dim v As Short =Value
	If txtSize.Tag = 1 Then
		txtSize.Tag = 0
	Else
		txtSize.Text = v
	End If
	DrawMosaic
End Sub		
