﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private cv As Canvas 	
	Private Img As Image	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

End Sub
Public Sub Sepia(c As Canvas) 
	Dim x, y, wdt, hgt As Int
	Dim rgb(4) As Int
	Dim r, g, b As Int
	Dim Rr, Gg, Bb As Float
    Dim newR As Double, newG As Double, newB As Double
	cv = c
	Img = cv.Snapshot 
	wdt = Img.Width 
	hgt=Img.Height 	
	Dim ARGB,  lGray As Int
	Dim ARGB1 As Paint
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	InputJO = Img
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)	
	cv.ClearRect(0,0,cv.Width,cv.Height)	
	For y=0 To hgt-1
		For x=0 To wdt -1 
			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(x,y))
			rgb = modFunctions.getRGB(ARGB)
			Rr = rgb(1)
			Gg = rgb(2)
			Bb = rgb(3)
        	newR = Rr * 0.393 + Gg * 0.769 + Bb * 0.189
        	newG = Rr * 0.349 + Gg * 0.686 + Bb * 0.168
        	newB = Rr * 0.272 + Gg * 0.534 + Bb * 0.131
	        r = newR
	        g = newG
		    b = newB
	        If r > 255 Then r = 255
	        If g > 255 Then g = 255
	        If b > 255 Then b = 255			
			ARGB1 = fx.Colors.rgb(r, g, b)
			lGray=fx.Colors.To32Bit(ARGB1)
			WriterJO.RunMethod("setArgb",Array As Object(x , y ,lGray))				
		Next
	Next
	cv.DrawImage(OutputJO,0,0,wdt,hgt)	
End Sub
